diff -pruN 7/debian/changelog 11/debian/changelog
--- 7/debian/changelog	2019-09-16 14:10:17.000000000 +0000
+++ 11/debian/changelog	2020-08-03 15:25:53.000000000 +0000
@@ -1,3 +1,35 @@
+cross-toolchain-base-mipsen (11) unstable; urgency=medium
+
+  * Rebase c-t-b 47
+    - build with gcc 10
+    - build with glibc 3.31
+    - build with binutils 2.35
+
+ -- YunQiang Su <syq@debian.org>  Mon, 03 Aug 2020 23:25:53 +0800
+
+cross-toolchain-base-mipsen (10) unstable; urgency=medium
+
+  * Don't generate Build-Using linux with binNMU version tail. (Closes: #942565)
+  * Build with glibc 2.30+ and binutils 2.34+.
+
+ -- YunQiang Su <syq@debian.org>  Sun, 22 Mar 2020 19:44:30 +0800
+
+cross-toolchain-base-mipsen (9) unstable; urgency=medium
+
+  * Based on cross-toolchain-base 43:
+    - Build using binutils 2.33.50.
+    - Build using linux 5.4.
+    - Bump standards version.
+
+ -- YunQiang Su <syq@debian.org>  Thu, 09 Jan 2020 16:18:11 +0800
+
+cross-toolchain-base-mipsen (8) unstable; urgency=medium
+
+  * Remove merged patch for binutils. (Closes: #934716)
+  * Remove autopkgtests. (Closes: #941057)
+
+ -- YunQiang Su <syq@debian.org>  Wed, 16 Oct 2019 23:09:43 +0800
+
 cross-toolchain-base-mipsen (7) unstable; urgency=medium
 
   * Based on cross-toolchain-base 42.
diff -pruN 7/debian/control 11/debian/control
--- 7/debian/control	2019-09-16 14:09:47.000000000 +0000
+++ 11/debian/control	2020-08-03 15:25:53.000000000 +0000
@@ -3,15 +3,15 @@ Section: devel
 Priority: optional
 Maintainer: Cross Toolchain Base Team <cross-toolchain-base-devs@lists.launchpad.net>
 Uploaders: Matthias Klose <doko@debian.org>, Dimitri John Ledkov <xnox@debian.org>, YunQiang Su <syq@debian.org>
-Vcs-Browser: https://salsa.debian.org/toolchain-team/cross-toolchain-base
-Vcs-Git: https://salsa.debian.org/toolchain-team/cross-toolchain-base.git
-Standards-Version: 4.4.0
+Vcs-Browser: https://salsa.debian.org/toolchain-team/cross-toolchain-base/-/tree/mipsen
+Vcs-Git: https://salsa.debian.org/toolchain-team/cross-toolchain-base.git -b mipse
+Standards-Version: 4.5.0
 Build-Depends: binutils-multiarch,
   dpkg (>= 1.16.0~ubuntu6), rdfind, symlinks, lsb-release,
-  binutils-source (>= 2.32.51.20190909-1~),
-  glibc-source (>= 2.29-0~),
-  gcc-9-source (>= 9.2.1-8~),
-  linux-source (>= 5.2), linux-libc-dev (>= 5.2),
+  binutils-source (>= 2.35-1~),
+  glibc-source (>= 2.31-1~),
+  gcc-10-source (>= 10.1.0-5~),
+  linux-source (>= 5.7), linux-libc-dev (>= 5.7),
   autoconf (>= 2.64), autoconf2.64, autogen,
   automake, bison (>= 1:2.3), chrpath, debhelper (>= 9),
   dpkg-dev (>= 1.15.3.1), fakeroot, file, flex,
diff -pruN 7/debian/control.source.in 11/debian/control.source.in
--- 7/debian/control.source.in	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/control.source.in	2020-08-03 15:25:53.000000000 +0000
@@ -3,9 +3,9 @@ Section: devel
 Priority: optional
 Maintainer: Cross Toolchain Base Team <cross-toolchain-base-devs@lists.launchpad.net>
 Uploaders: Matthias Klose <doko@debian.org>, Dimitri John Ledkov <xnox@debian.org>, YunQiang Su <syq@debian.org>
-Vcs-Browser: https://salsa.debian.org/toolchain-team/cross-toolchain-base
-Vcs-Git: https://salsa.debian.org/toolchain-team/cross-toolchain-base.git
-Standards-Version: 4.4.0
+Vcs-Browser: https://salsa.debian.org/toolchain-team/cross-toolchain-base/-/tree/mipsen
+Vcs-Git: https://salsa.debian.org/toolchain-team/cross-toolchain-base.git -b mipse
+Standards-Version: 4.5.0
 Build-Depends: binutils-multiarch,
   dpkg (>= 1.16.0~ubuntu6), rdfind, symlinks, lsb-release,
   binutils-source (>= MIN_VER_BINUTILS),
diff -pruN 7/debian/kernelarch.make 11/debian/kernelarch.make
--- 7/debian/kernelarch.make	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/kernelarch.make	2020-08-03 15:25:53.000000000 +0000
@@ -1,10 +1,3 @@
-# Black-belt magic
-, := ,
-space :=
-space +=
-$(space) := 
-$(space) +=
-
 KERNEL_ARCH_alpha:=alpha
 KERNEL_ARCH_arm64:=arm64
 KERNEL_ARCH_armhf:=arm
diff -pruN 7/debian/patches/binutils/mips-cross-to-mipsen.patch 11/debian/patches/binutils/mips-cross-to-mipsen.patch
--- 7/debian/patches/binutils/mips-cross-to-mipsen.patch	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/patches/binutils/mips-cross-to-mipsen.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-diff -urN binutils-2.32.51.20190909/debian/rules binutils-2.32.51.20190909-new/debian/rules
---- binutils-2.32.51.20190909/debian/rules	2019-09-05 10:47:40.000000000 +0000
-+++ binutils-2.32.51.20190909-new/debian/rules	2019-09-12 09:43:46.129629602 +0000
-@@ -96,12 +96,11 @@
- install_script = install -m 755
- install_binary = install -m 755 -s --strip-program="$(STRIP)"
- 
--NATIVE_ARCHS ?= amd64 i386 arm64 armhf armel mipsel mips64el \
--	ppc64el s390x
--NATIVE_ARCHS += alpha hppa ia64 m68k mips64 powerpc ppc64 \
-+NATIVE_ARCHS ?= amd64 i386 arm64 armhf armel ppc64el s390x
-+NATIVE_ARCHS += alpha hppa ia64 m68k powerpc ppc64 \
- 	riscv64 sh4 sparc64 x32
- NATIVE_ARCHS += hurd-i386 kfreebsd-amd64 kfreebsd-i386
--NATIVE_ARCHS += mipsn32 mipsn32el
-+NATIVE_ARCHS += mips mipsel mipsn32 mipsn32el mips64 mips64el
- NATIVE_ARCHS += mipsn32r6 mipsn32r6el mipsr6 mipsr6el mips64r6 mips64r6el
- #NATIVE_ARCHS += nios2 or1k s390 sparc
- 
-@@ -144,8 +143,8 @@
-   with_cross	= yes
-   same_source	=
-   ifeq (,$(CROSS_ARCHS))
--    ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32 arm64 ppc64el))
--      CROSS_ARCHS = mipsel mips64el mips64 mipsn32 mipsn32el
-+    ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32))
-+      CROSS_ARCHS = mips mipsel mips64el mips64 mipsn32 mipsn32el
-       CROSS_ARCHS += mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
-     else
-       CROSS_ARCHS =
-@@ -182,7 +181,6 @@
- HOST_ARCHS_armhf = amd64 i386 x32 arm64 ppc64el
- HOST_ARCHS_armel = amd64 i386 x32 arm64 ppc64el
- HOST_ARCHS_arm64 = amd64 i386 x32 ppc64el
--HOST_ARCHS_mipsel = amd64 i386 x32
- HOST_ARCHS_powerpc = amd64 i386 x32 ppc64el
- HOST_ARCHS_ppc64el = amd64 i386 x32 ppc64 arm64
- HOST_ARCHS_s390x = amd64 i386 x32 arm64 ppc64el
-@@ -194,15 +192,17 @@
- HOST_ARCHS_alpha = amd64 i386 x32
- HOST_ARCHS_hppa = amd64 i386 x32
- HOST_ARCHS_m68k = amd64 i386 x32
--HOST_ARCHS_mips64 = amd64 i386 x32
--HOST_ARCHS_mips64el = amd64 i386 x32
- HOST_ARCHS_ppc64 = amd64 i386 x32 ppc64el
- HOST_ARCHS_sh4 = amd64 i386 x32
- HOST_ARCHS_sparc64 = amd64 i386 x32
- HOST_ARCHS_x32 = amd64 arm64 i386 ppc64el
- 
-+HOST_ARCHS_mips = amd64 i386 x32
-+HOST_ARCHS_mipsel = amd64 i386 x32
- HOST_ARCHS_mipsn32 = amd64 i386 x32
- HOST_ARCHS_mipsn32el = amd64 i386 x32
-+HOST_ARCHS_mips64 = amd64 i386 x32
-+HOST_ARCHS_mips64el = amd64 i386 x32
- 
- HOST_ARCHS_mipsr6 = amd64 i386 x32
- HOST_ARCHS_mipsr6el = amd64 i386 x32
-@@ -266,7 +266,7 @@
- 
- gold_targets = \
- 	amd64 arm64 armel armhf i386 \
--	mipsel mipsn32 mipsn32el mips64 mips64el \
-+	mips mipsel mipsn32 mipsn32el mips64 mips64el \
- 	mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el \
- 	powerpc ppc64 ppc64el sparc sparc64 s390x \
- 	x32 kfreebsd-amd64 kfreebsd-i386 hurd-i386
diff -pruN 7/debian/patches/binutils/series 11/debian/patches/binutils/series
--- 7/debian/patches/binutils/series	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/patches/binutils/series	2020-08-03 15:25:53.000000000 +0000
@@ -1 +1 @@
-mips-cross-to-mipsen.patch
+# empty file
diff -pruN 7/debian/patches/glibc/debian/glibc-build-tools.diff 11/debian/patches/glibc/debian/glibc-build-tools.diff
--- 7/debian/patches/glibc/debian/glibc-build-tools.diff	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/patches/glibc/debian/glibc-build-tools.diff	2020-08-03 15:25:53.000000000 +0000
@@ -1,13 +1,13 @@
---- glibc-2.27/debian/rules~	2018-02-22 10:47:56.000000000 +0100
-+++ glibc-2.27/debian/rules	2018-04-02 19:07:06.562170629 +0200
-@@ -105,8 +105,8 @@
- CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION) -no-pie -fno-PIE
- CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION) -no-pie -fno-PIE
+--- a/debian/rules
++++ b/debian/rules
+@@ -104,8 +104,8 @@ TIMEOUTFACTOR = 25
+ CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION)
+ CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION)
  MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
 -BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
 -BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)
 +BUILD_CC = /usr/bin/$(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
 +BUILD_CXX = /usr/bin/$(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)
  
- BUILD_CFLAGS = -O2 -g
- HOST_CFLAGS = -pipe -O2 -g $(call xx,extra_cflags)
+ BUILD_CFLAGS = -O2 -g -fdebug-prefix-map=$(CURDIR)=.
+ HOST_CFLAGS = -pipe -O2 -g -fdebug-prefix-map=$(CURDIR)=. $(call xx,extra_cflags)
diff -pruN 7/debian/patches/glibc/debian/local-kill-locales.patch 11/debian/patches/glibc/debian/local-kill-locales.patch
--- 7/debian/patches/glibc/debian/local-kill-locales.patch	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/patches/glibc/debian/local-kill-locales.patch	2020-08-03 15:25:53.000000000 +0000
@@ -1,6 +1,6 @@
 --- a/debian/rules
 +++ b/debian/rules
-@@ -141,10 +141,12 @@ else
+@@ -142,10 +142,12 @@ else
    else
      DEB_UDEB_PACKAGES = $(libc)-udeb
    endif
@@ -15,7 +15,7 @@
  # Generic kernel version check
 --- a/localedata/SUPPORTED
 +++ b/localedata/SUPPORTED
-@@ -1,498 +1,3 @@
+@@ -1,499 +1,3 @@
  # This file names the currently supported and somewhat tested locales.
  # If you have any additions please file a glibc bug report.
  SUPPORTED-LOCALES=\
@@ -352,6 +352,7 @@
 -ml_IN/UTF-8 \
 -mn_MN/UTF-8 \
 -mni_IN/UTF-8 \
+-mnw_MM/UTF-8 \
 -mr_IN/UTF-8 \
 -ms_MY.UTF-8/UTF-8 \
 -ms_MY/ISO-8859-1 \
diff -pruN 7/debian/rules 11/debian/rules
--- 7/debian/rules	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/rules	2020-08-03 15:25:53.000000000 +0000
@@ -1,5 +1,8 @@
 #!/usr/bin/make -f
 
+, := ,
+space := $(EMPTY) $(EMPTY)
+
 export SHELL = /bin/bash
 
 # prefix for builds - without leading slash
@@ -67,10 +70,15 @@ ifeq ($(DEB_NAME_ACT),cross-toolchain-ba
   endif
 endif
 
-MIN_VER_GLIBC		:= 2.29-0~
-MIN_VER_LINUX		:= 5.2
-MIN_VER_GCC		:= 9.2.1-8~
-MIN_VER_BINUTILS	:= 2.32.51.20190909-1~
+# ===============================================================
+# ATTENTION: don't forget to update these in debian/tests/control
+# ===============================================================
+MIN_VER_GLIBC		:= 2.31-1~
+MIN_VER_LINUX		:= 5.7
+MIN_VER_GCC		:= 10.1.0-5~
+MIN_VER_BINUTILS	:= 2.35-1~
+VER_GCC_BASE		:= 10
+libgcc_base		:= gcc-s
 
 DEB_VER_LINUX  := $(shell apt-cache policy linux-libc-dev | awk '/^ \*\*\*/ {print $$2}')
 ifeq ($(vendor),Ubuntu)
@@ -78,26 +86,25 @@ ifeq ($(vendor),Ubuntu)
 else
   VER_LINUX      := $(shell echo $(DEB_VER_LINUX) | sed 's/^\([0-9]*\.[0-9]*\).*/\1/')
 endif
-VER_GCC_BASE   := 9
 ifeq ($(vendor),Ubuntu)
-  MIN_VER_GLIBC	:= 2.30-0ubuntu1~
-  VER_GCC_BASE	:= 9
-  MIN_VER_GCC	:= 9.2.1-6~
-  MIN_VER_BINUTILS	:= 2.32-3~
-  MIN_VER_BINUTILS	:= 2.32.51.20190702-1~
-  MIN_VER_LINUX		:= 5.0
-endif
-
-VER_GCC          := $(shell dpkg-parsechangelog -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
-DEB_VER_GCC      := $(shell dpkg-parsechangelog -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')
-VER_BINUTILS     := $(shell dpkg-parsechangelog -l/usr/src/binutils/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-'|cut -d '.' -f1-3)
-PKG_VER_BINUTILS := $(shell dpkg-parsechangelog -l/usr/src/binutils/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
-DEB_VER_BINUTILS := $(shell dpkg-parsechangelog -l/usr/src/binutils/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')
-VER_GLIBC        := $(shell dpkg-parsechangelog -l/usr/src/glibc/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
-DEB_VER_GLIBC    := $(shell dpkg-parsechangelog -l/usr/src/glibc/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')
+  MIN_VER_GLIBC		:= 2.31-0ubuntu1~
+  VER_GCC_BASE		:= 9
+  MIN_VER_GCC		:= 9.3.0-15~
+  MIN_VER_BINUTILS	:= 2.34-5~
+  MIN_VER_LINUX		:= 5.4
+  libgcc_base		:= gcc
+endif
+
+VER_GCC          := $(shell dpkg-parsechangelog -SVersion -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | cut -f 1 -d '-')
+DEB_VER_GCC      := $(shell dpkg-parsechangelog -SVersion -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog)
+VER_BINUTILS     := $(shell dpkg-parsechangelog -SVersion -l/usr/src/binutils/debian/changelog | cut -f 1 -d '-'|cut -d '.' -f1-3)
+PKG_VER_BINUTILS := $(shell dpkg-parsechangelog -SVersion -l/usr/src/binutils/debian/changelog | cut -f 1 -d '-')
+DEB_VER_BINUTILS := $(shell dpkg-parsechangelog -SVersion -l/usr/src/binutils/debian/changelog)
+VER_GLIBC        := $(shell dpkg-parsechangelog -SVersion -l/usr/src/glibc/debian/changelog | cut -f 1 -d '-')
+DEB_VER_GLIBC    := $(shell dpkg-parsechangelog -SVersion -l/usr/src/glibc/debian/changelog)
 
-LINUX_BUILT_USING := linux (= $(DEB_VER_LINUX))
-GLIBC_BUILT_USING := binutils (= $(DEB_VER_BINUTILS)), linux (= $(DEB_VER_LINUX)), gcc-$(VER_GCC_BASE) (= $(DEB_VER_GCC)), glibc (= $(DEB_VER_GLIBC))
+LINUX_BUILT_USING := linux (= $(shell echo $(DEB_VER_LINUX) | sed 's/+.*$$//'))
+GLIBC_BUILT_USING := binutils (= $(DEB_VER_BINUTILS)), linux (= $(shell echo $(DEB_VER_LINUX) | sed 's/+.*$$//')), gcc-$(VER_GCC_BASE) (= $(DEB_VER_GCC)), glibc (= $(DEB_VER_GLIBC))
 
 control_vars = '-Vbu:linux=$(LINUX_BUILT_USING)' '-Vbu:glibc=$(GLIBC_BUILT_USING)'
 
@@ -223,10 +230,15 @@ $(stamp)install-binutils.%: $(stamp)buil
 	dpkg-deb -x binutils-common_${DEB_VER_BINUTILS}_${HOST_ARCH}.deb debian/tmp.${CROSS_ARCH}
 	dpkg-deb -x binutils-${CROSS_PKG_GNU_TYPE}_${DEB_VER_BINUTILS}_${HOST_ARCH}.deb debian/tmp.${CROSS_ARCH}
 	$(if $(filter $(HOST_ARCH),$(CROSS_ARCH)), \
-	  dpkg-deb -x libbinutils_${DEB_VER_BINUTILS}_${HOST_ARCH}.deb debian/tmp.${CROSS_ARCH})
+	  dpkg-deb -x libbinutils_${DEB_VER_BINUTILS}_${HOST_ARCH}.deb debian/tmp.${CROSS_ARCH}; \
+	  dpkg-deb -x libctf0_${DEB_VER_BINUTILS}_${HOST_ARCH}.deb debian/tmp.${CROSS_ARCH}; \
+	  dpkg-deb -x libctf-nobfd0_${DEB_VER_BINUTILS}_${HOST_ARCH}.deb debian/tmp.${CROSS_ARCH}; \
+	)
 	mkdir -p debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH)/binutils;
 	mv debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH)/lib{bfd,opcodes}-*.so \
 	  debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH)/binutils;
+	mv debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH)/libctf*.so* \
+	  debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH)/binutils;
 	rm -f debian/tmp.${CROSS_ARCH}/usr/bin/*.exe
 	for i in debian/tmp.${CROSS_ARCH}/usr/bin/*; do \
 	  mv $$i $$i.exe; \
@@ -252,13 +264,14 @@ $(stamp)init-gcc:
 	  QUILT_PATCHES=${CURDIR}/debian/patches/gcc quilt --quiltrc /dev/null  push -a ; \
 	fi;
 #	set -ex; \
-#	if dpkg --compare-versions $(DEB_VER_GCC) le 7.3.0-18; then \
+#	if dpkg --compare-versions $(DEB_VER_GCC) le 9.3.0-6; then \
 #	  cd gcc; \
 #	  patch -p1 < ../debian/patches/gcc/updates.diff; \
 #	fi
 	touch $@
 
 $(stamp)build-gcc1.%: $(stamp)init-gcc $(stamp)install-binutils.%
+
 	@echo START $@
 	echo ${CROSS_ARCH} >gcc/debian/target
 	cd gcc && \
@@ -359,7 +372,7 @@ $(stamp)build-gcc2.%: $(stamp)init-gcc $
 $(stamp)install-gcc2.%: $(stamp)build-gcc2.%
 	@echo START $@
 	$(call install_gcc)
-	dpkg-deb -x libgcc[124]-${CROSS_ARCH}-cross_${DEB_VER_GCC}_all.deb \
+	dpkg-deb -x lib$(libgcc_base)[124]-${CROSS_ARCH}-cross_${DEB_VER_GCC}_all.deb \
 		debian/tmp.${CROSS_ARCH}
 ifneq (,$(ARM32_MULTILIBS))
 	$(if $(filter $(CROSS_ARCH),armhf), \
@@ -465,7 +478,7 @@ $(stamp)build-glibc1.%: $(stamp)init-gli
 # FIXME: why debian/libgcc1-armel-cross?
 	cd glibc-${VER_GLIBC} && \
 	  PATH=${CURDIR}/debian/tmp.${CROSS_ARCH}/$(PF)/bin/:${PATH} \
-	  LD_LIBRARY_PATH=$(call binutils_ldpath,$*):${CURDIR}/gcc/debian/libgcc1-armel-cross/usr/${CROSS_GNU_TYPE}/lib/ \
+	  LD_LIBRARY_PATH=$(call binutils_ldpath,$*):${CURDIR}/gcc/debian/lib$(libgcc_base)1-armel-cross/usr/${CROSS_GNU_TYPE}/lib/ \
 	  LINUX_SOURCE=${CURDIR}/debian/tmp.${CROSS_ARCH}/usr \
 	  PATCHED_SOURCES=yes \
 	  WITH_BUILD_SYSROOT=${CURDIR}/debian/tmp.${CROSS_ARCH} \
@@ -546,7 +559,7 @@ $(stamp)build-glibc2.%: $(stamp)init-gli
 # FIXME: why debian/libgcc1-armel-cross?
 	cd glibc-${VER_GLIBC} && \
 	  PATH=${CURDIR}/debian/tmp.${CROSS_ARCH}/$(PF)/bin/:${PATH} \
-	  LD_LIBRARY_PATH=$(call binutils_ldpath,$*):${CURDIR}/gcc/debian/libgcc1-armel-cross/usr/${CROSS_GNU_TYPE}/lib/ \
+	  LD_LIBRARY_PATH=$(call binutils_ldpath,$*):${CURDIR}/gcc/debian/lib$(libgcc_base)1-armel-cross/usr/${CROSS_GNU_TYPE}/lib/ \
 	  LINUX_SOURCE=${CURDIR}/debian/tmp.${CROSS_ARCH}/usr \
 	  DEB_BUILD_OPTIONS="nocheck notest notests $(DH_PARALLEL)" \
 	  PATCHED_SOURCES=yes \
@@ -736,8 +749,8 @@ ifneq (,$(filter mips64r6el, $(CROSS_ARC
 	libc6-dev-mipsn32-mips64r6el-cross_${VER_GLIBC}-*_all.deb
 endif
 
-#           libgcc1-${CROSS_ARCH}-cross_${DEB_VER_GCC}_all.deb  \
-#           libgcc1-dbg-${CROSS_ARCH}-cross_${DEB_VER_GCC}_all.deb  \
+#           lib$(libgcc_base)1-${CROSS_ARCH}-cross_${DEB_VER_GCC}_all.deb  \
+#           lib$(libgcc_base)1-dbg-${CROSS_ARCH}-cross_${DEB_VER_GCC}_all.deb  \
 
 #
 # Repack resulting packages to make some changes;
@@ -821,17 +834,17 @@ $(stamp)repack-%:
 	  libc6-sparc-sparc64-cross) \
 	    rm -f $$tmp/usr/*/lib/ld-linux.so.2;; \
 	esac; \
-	if [ 'libgcc1-dbg-$${cross_arch}-cross' = $$pkgname ]; then \
-	  sed -i -e 's/^Depends.*/Depends: libgcc1-$${cross_arch}-cross (= 1:${DEB_VER_GCC}$(CROSS_EXT))/g' $$tmp/DEBIAN/control; \
-	  ln -sf libgcc1-$${cross_arch}-cross $$tmp/usr/share/doc/libgcc1-dbg-$${cross_arch}-cross; \
+	if [ 'lib$(libgcc_base)1-dbg-$${cross_arch}-cross' = $$pkgname ]; then \
+	  sed -i -e 's/^Depends.*/Depends: lib$(libgcc_base)1-$${cross_arch}-cross (= 1:${DEB_VER_GCC}$(CROSS_EXT))/g' $$tmp/DEBIAN/control; \
+	  ln -sf lib$(libgcc_base)1-$${cross_arch}-cross $$tmp/usr/share/doc/lib$(libgcc_base)1-dbg-$${cross_arch}-cross; \
 	fi; \
-	if [ 'libgcc1-$${cross_arch}-cross' = $$pkgname ]; then \
+	if [ 'lib$(libgcc_base)1-$${cross_arch}-cross' = $$pkgname ]; then \
 	  sed -i -e'/^Depends/d' $$tmp/DEBIAN/control; \
-	  rm $$tmp/usr/share/doc/libgcc1-$${cross_arch}-cross; \
-	  mkdir -p $$tmp/usr/share/doc/libgcc1-$${cross_arch}-cross; \
-	  mv $$tmp/usr/share/doc/libgcc1-$${cross_arch}-cross/changelog.Debian.gz \
-	     $$tmp/usr/share/doc/libgcc1-$${cross_arch}-cross/changelog.Debian.gcc-${VER_GCC_BASE}.gz; \
-	  gzip -cn9 debian/changelog > $$tmp/usr/share/doc/libgcc1-$${cross_arch}-cross/changelog.Debian.gz;\
+	  rm $$tmp/usr/share/doc/lib$(libgcc_base)1-$${cross_arch}-cross; \
+	  mkdir -p $$tmp/usr/share/doc/lib$(libgcc_base)1-$${cross_arch}-cross; \
+	  mv $$tmp/usr/share/doc/lib$(libgcc_base)1-$${cross_arch}-cross/changelog.Debian.gz \
+	     $$tmp/usr/share/doc/lib$(libgcc_base)1-$${cross_arch}-cross/changelog.Debian.gcc-${VER_GCC_BASE}.gz; \
+	  gzip -cn9 debian/changelog > $$tmp/usr/share/doc/lib$(libgcc_base)1-$${cross_arch}-cross/changelog.Debian.gz;\
 	fi; \
 	if [ 'linux-libc-dev-$${cross_arch}-cross' = $$pkgname ]; then \
 	  mkdir -p $$tmp/usr/share/doc/$$pkgname; \
@@ -1181,6 +1194,9 @@ $(stamp)dpkg-cross: build
 	touch $@
 
 control:
+ifeq ($(DEB_NAME_ACT),cross-toolchain-base-mipsen)
+	rm -rf debian/tests
+endif
 	@echo START $@
 	( \
 	  sed -e "s/CROSS_ARCH/${CROSS_ARCH}/g" \
diff -pruN 7/debian/tests/build 11/debian/tests/build
--- 7/debian/tests/build	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/tests/build	1970-01-01 00:00:00.000000000 +0000
@@ -1,30 +0,0 @@
-#!/bin/sh
-
-set -e
-
-arch=$(dpkg --print-architecture)
-
-echo "Testing cross builds on $arch ..."
-
-CPUS=$(getconf _NPROCESSORS_ONLN)
-case "$CPUS" in
-  [0-9]|[0-9][0-9]|[0-9][0-9][0-9]) ;;
-  *) CPUS=1
-esac
-
-case "$arch" in
-  amd64)
-    CROSS_ARCHS="ppc64el";;
-  i386)
-    CROSS_ARCHS="arm64";;
-  ppc64el)
-    CROSS_ARCHS="arm64";;
-  arm64)
-    CROSS_ARCHS="armhf";;
-  *)
-    echo "Skipping cross builds on $arch"
-    exit 0;;
-esac
-
-set -x
-CROSS_ARCHS="$CROSS_ARCHS" DEB_BUILD_OPTIONS="parallel=$CPUS nopgo nolto" dpkg-buildpackage -d -b --no-sign
diff -pruN 7/debian/tests/control 11/debian/tests/control
--- 7/debian/tests/control	2019-09-16 14:00:15.000000000 +0000
+++ 11/debian/tests/control	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-Tests: build
-# this doesn't work well, with building only one architecture
-#Depends: build-essential
-#Restrictions: build-needed
-Depends: build-essential,
-  fakeroot,
-  binutils-source (>= 2.32.51-1~),
-  glibc-source (>= 2.29-1~),
-  gcc-9-source (>= 9.2.1-8~),
-  linux-source (>= 5.2), linux-libc-dev (>= 5.2),
-  autoconf (>= 2.64), autoconf2.64, autogen,
-  automake, bison (>= 1:2.3), chrpath, debhelper (>= 9),
-  dpkg-dev (>= 1.15.3.1), fakeroot, file, flex,
-  dwz, gawk, gettext, gperf (>= 3.0.1), kernel-wedge (>= 2.24),
-  libisl-dev, libmpc-dev, libelf-dev,
-  libmpfr-dev (>= 2.3.0), rsync, xmlto, libtool, lsb-release, lzma, m4,
-  make (>= 3.81), kmod | module-init-tools, symlinks,
-  patchutils, procps, quilt, rdfind, coreutils (>= 2.26) | realpath (>= 1.9.12),
-  sed (>= 4.0.5-4), sharutils, tar (>= 1.22), xz-utils,
-  asciidoc, texinfo, cpio, python3, bc,
-  libconfig-auto-perl, libfile-temp-perl, libconfig-auto-perl,
-  libfile-homedir-perl, liblocale-gettext-perl, libunwind-dev [amd64 i386 x32]
-# build process emits warnings on stderr
-Restrictions: allow-stderr
